# Note: this file is a template python-file and it was generated from config_file :D:/RVS/RobotVisionSuite/RobotVisionSuite/xmlChange.json.
############################################
import RVS_LOG
# write log to RVS_log_file, for example:
# RVS_LOG.write('your own log string')
import numpy
from enum import Enum
import re
import os
import argparse


# ToDo: import the moudle you need


# The following class 'RVSPyClass' is the interface-class between your python_moudle and RVS.



class RVSPyClass:
  def __init__(self):
    # all io_port_name and para_name have been list as below.
    self.inputDir = ''
    self.outputDir = ''
    ##########################################
    # ToDo: remove 'pass' and add your code for initial
    pass


  def inputData(self,input):
    self.inputDir = input[0]
    self.outputDir = input[1]
    pass

  def outputData(self):
    return [ ]

  def re_ini(self):

    ##########################################
    # ToDo: remove 'pass' and add your code
    pass

  def replace_text(text):
    # 定义替换规则
    replacements = [
      (r'(\b\w*pose)_roll\b', r'\1_rx'),
      (r'(\b\w*pose)_pitch\b', r'\1_ry'),
      (r'(\b\w*pose)_yaw\b', r'\1_rz'),
      (r'(pose)\.roll\b', r'pose.rx'),
      (r'(pose)\.pitch\b', r'pose.ry'),
      (r'(pose)\.yaw\b', r'pose.rz'),
    ]

    modified_lines = 0
    lines = text.splitlines()
    new_lines = []

    for line in lines:
      original_line = line
      for pattern, replacement in replacements:
        line = re.sub(pattern, replacement, line)
      if line != original_line:
        modified_lines += 1
      new_lines.append(line)

    return '\n'.join(new_lines), modified_lines
    pass

  def process_file(input_file, output_file):
      # 读取文件内容
      with open(input_file, 'r', encoding='utf-8') as file:
        data = file.read()
      # 替换文本并统计修改的行数
      modified_data, modified_lines = RVSPyClass.replace_text(data)
      # 写入修改后的内容
      with open(output_file, 'w', encoding='utf-8') as file:
        file.write(modified_data)
      return modified_lines
      pass
  def process(self):
    input_dir = self.inputDir
    output_dir = self.outputDir
    total_modified_lines = 0

    # 确保输出目录存在
    os.makedirs(output_dir, exist_ok=True)

    # 遍历输入目录中的所有XML文件
    for filename in os.listdir(input_dir):
      if filename.endswith('.xml'):
        input_file = os.path.join(input_dir, filename)
        output_file = os.path.join(output_dir, filename)
        modified_lines = RVSPyClass.process_file(input_file, output_file)
        total_modified_lines += modified_lines
        print(f'Processed {filename}, modified {modified_lines} lines.')

    print(f'Total modified lines: {total_modified_lines}')
    print("output to directory", output_dir)

    
  ############################################
  # ToDo: add your own function
  

##############################################
# ToDo: add your own code
